_

Zły rezultat getboundingbox w użyciu ze splinem

Forum poświęcone flagowemu produktowi oraz aplikacjom pochodnym Autodesku. To jedyne forum mające w tytule nazwę programu, a to ze względu na jego olbrzymią popularność w Polsce. Można tutaj umieszczać również posty z ogólnie pojętej tematyki "Kreślarskie 2D".

Zły rezultat getboundingbox w użyciu ze splinem

Postprzez andkal » cze 01, 2019 11:03

Czemu funkcja vla-getbounding box z użyciu ze splinem daje mi prostokąt większy niż granice splajnu? Snapy są wyłączone.
Kod: Zaznacz cały
(defun c:test ( / )
    (vla-getboundingbox (vlax-ename->vla-object (car(entsel)) )  'minPt 'maxPt )
    (setq minPt (vlax-safearray->list minPt)    maxPt (vlax-safearray->list maxPt) )
    (command "_rectang" minPt maxPt)
);defun
Załączniki
test.JPG
test.JPG (18.49 KiB) Przeglądane 383 razy
http://www.autolisps.blogspot.com - handy plugins for autocad
andkal
 
Posty: 68
Dołączył(a): paź 01, 2017 22:10

Re: Zły rezultat getboundingbox w użyciu ze splinem

Postprzez kojacek » cze 02, 2019 20:50

andkal napisał(a):Czemu funkcja vla-getbounding box z użyciu ze splinem daje mi prostokąt większy niż granice splajnu? Snapy są wyłączone.
Kod: Zaznacz cały
(defun c:test ( / )
    (vla-getboundingbox (vlax-ename->vla-object (car(entsel)) )  'minPt 'maxPt )
    (setq minPt (vlax-safearray->list minPt)    maxPt (vlax-safearray->list maxPt) )
    (command "_rectang" minPt maxPt)
);defun


Problem jest znany od dawna: https://www.theswamp.org/index.php?topic=39136.0 Autodesk raczej nic z tym nie robi. Ja bym obcykał to tak:
1) Tymczasowo przekonwertował wybrane SLPLINE'y do (LW)POLYLINE np. ::(https://kojacek.wordpress.com/2016/11/07/konwersja-elipsy-do-polilinii/)
2) Zwrócił getboundingbox tenże
3) Usunął temp-a
Avatar użytkownika
kojacek
 
Posty: 5553
Dołączył(a): paź 03, 2005 20:17

Re: Zły rezultat getboundingbox w użyciu ze splinem

Postprzez andkal » cze 02, 2019 22:13

Tak też właśnie to rozwiązałem, chociaż jeden z użytkowników znalazł na to rozwiązanie dające dokładny rezultat. Polilinia daje boundingbox tylko przybliżony ale na tyle dokładny że wystarczający na moje potrzeby. Poruszyłem to na tym forum:

https://forums.autodesk.com/t5/visual-l ... 22#M385951
http://www.autolisps.blogspot.com - handy plugins for autocad
andkal
 
Posty: 68
Dołączył(a): paź 01, 2017 22:10


Powrót do AutoCAD

Kto przegląda forum

Użytkownicy przeglądający ten dział: Brak zidentyfikowanych użytkowników